/*!
 * quasar-ui-json-api-viewer v2.0.0-alpha.5
 * (c) 2021 Jeff Galbraith <jeff@quasar.dev>
 * Released under the MIT License.
 */
import{defineComponent,h,computed,ref,reactive,getCurrentInstance,watch,onBeforeMount}from"vue";import{QBadge,QList,QItem,Notify,ClosePopup,useQuasar,extend,QCard,QToolbar,QToolbarTitle,QInput,QIcon,QMenu,QCheckbox,QSeparator,QTabs,QTab,QSpace,QTabPanels,QTabPanel}from"quasar";import"prismjs";const NAME_PROP_COLOR=["bg-orange-8","bg-accent","bg-secondary","bg-warning"];var JsonApiItem=defineComponent({name:"JsonApiItem",props:{name:{type:String,required:!0},type:{type:String,default:"props"},json:{type:Object,required:!0},deprecatedColor:{type:String,default:"yellow-8"},deprecatedBackground:{type:String,default:"red-8"},removedColor:{type:String,default:"yellow-8"},removedBackground:{type:String,default:"red-8"}},setup(e,{slots:t}){function o(e,t){if(""===t?t="js":"vue"!==t&&"html"!==t||(t="html"),void 0!==Prism.languages[t]){const o=Prism.highlight(e,Prism.languages[t],t);return'<pre class="q-markdown--code">'+`<code class="q-markdown--code__inner language-${t}">${o}</code></pre>\n`}return""}function n(e,t){let o;return o=" [",t.returns?o+=t.returns.type:o+="void 0",o+="] ",void 0===t.params?o+=e+" ()":o+=e+" ("+Object.keys(t.params).join(", ")+")",o}function a(){let t="@"+e.name+" => function";return void 0===e.json.params?t+" ()":(t+=" ("+Object.keys(e.json.params).join(", ")+")",t)}function r(t,o,a=0){return"Function"===o.type&&(t=n(t,o)),h("div",{class:"component-api__row component-api__row--bordered row"},{default:()=>[x(t,NAME_PROP_COLOR[a]),k(o),void 0!==e.json.removedIn&&y(o),void 0===e.json.removedIn&&void 0!==e.json.deprecated&&g(o),void 0===e.json.removedIn&&void 0===e.json.deprecated&&j(o),w(o),v(o),b(o),_(o),f(o),d(o),p(o),l(o,a+1),i(o,a+1),s(o,a+1),c(o,a+1)]})}function l(e,t=0){if(void 0===e.params)return"";const o=Object.keys(e.params);return h("div",{class:"component-api__row--item full-width"},{default:()=>[h("div",{class:"component-api__row--label"},"Parameter"+(Object.keys(e.params).length>1?"s":"")),h("div",{},{default:()=>[o.map(o=>r(o,e.params[o],t))]})]})}function i(e,t=0){if(void 0===e.definition)return"";const o=Object.keys(e.definition);return h("div",{class:"component-api__row--item full-width"},{default:()=>[h("div",{class:"component-api__row--label"},"Definition"+(Object.keys(e.definition).length>1?"s":"")),h("div",{},{default:()=>[o.map(o=>r(o,e.definition[o],t))]})]})}function s(e,t=0){if(void 0===e.scope)return"";const o=Object.keys(e.scope);return h("div",{class:"component-api__row--item full-width"},{default:()=>[h("div",{class:"component-api__row--label"},"Scope"),h("div",{},{default:()=>[o.map(o=>r(o,e.scope[o],t))]})]})}function c(e,t=0){return void 0===e.returns?"":h("div",{class:"component-api__row--item full-width"},{default:()=>[h("div",{class:"component-api__row--label"},"Returns"),h("div",{},{default:()=>[null===e.returns&&"null",null!==e.returns&&r(void 0,e.returns,t)]})]})}function d(e){return void 0===e.values||e.values.length<=0?"":h("div",{class:"component-api__row--item col-auto"},{default:()=>[h("div",{class:"component-api__row--label"},"Value"+(e.values.length>1?"s":"")),h("div",{class:"component-api__row--values"},e.values.join(", "))]})}function u(e){const t=o(e,"js");return h("div",{class:"component-api__row--example",innerHTML:t})}function p(e){if(!(void 0===e.examples||e.examples.length<=0))return h("div",{class:"component-api__row--item col-auto"},{default:()=>[h("div",{class:"component-api__row--label"},"Example"+(e.examples.length>1?"s":"")),h("div",{class:"component-api__row--value"},{default:()=>[...e.examples.map((e,t)=>u(e))]})]})}function m(e){return(e||"").replace(/\`(.*?)\`/g,(e,t,o)=>{return'<code class="q-markdown--token">'+t+"</code>"}).replace(/\*{2}(\w*)\*{2}/g,(e,t,o)=>{return"<strong>"+t+"</strong>"})}function f(e){if(void 0===e.desc)return;const t=m(e.desc);return h("div",{class:"component-api__row--item full-width"},{default:()=>[h("div",{class:"component-api__row--label"},"Description"),h("div",{class:"component-api__row--value"},{default:()=>[h("div",{innerHTML:t})]})]})}function v(e){return void 0===e.sync?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},{default:()=>[h("div",{class:"component-api__row--label"},"Sync"),h("div",{class:"component-api__row--value"},{default:()=>[h("div",e.sync)]})]})}function w(e){return void 0===e.required?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},{default:()=>[h("div",{class:"component-api__row--label"},"Required"),h("div",{class:"component-api__row--value"},{default:()=>[h("div",e.required)]})]})}function _(e){return void 0===e.applicable?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},{default:()=>[h("div",{class:"component-api__row--label"},"Applicable"),h("div",{class:"component-api__row--value"},{default:()=>[h("div",e.applicable.join(", "))]})]})}function b(e){return void 0===e.default?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},{default:()=>[h("div",{class:"component-api__row--label"},"Default"),h("div",{class:"component-api__row--value"},{default:()=>[h("div",e.default)]})]})}function y(t){return void 0===t.removedIn?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},{default:()=>[h("div",{class:"component-api__row--label"},{default:()=>[h("span",{class:"rounded-borders text-"+e.removedColor+" bg-"+e.removedBackground},"Removed in")]}),h("div",{class:"component-api__row--value"},{default:()=>[h("div",{default:()=>[h("span",{class:"rounded-borders text-"+e.deprecatedColor+" bg-"+e.deprecatedBackground},t.removedIn)]})]})]})}function g(t){return void 0===t.deprecated?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},{default:()=>[h("div",{class:"component-api__row--label"},{default:()=>[h("span",{class:"rounded-borders text-"+e.deprecatedColor+" bg-"+e.deprecatedBackground},"Deprecated")]}),h("div",{class:"component-api__row--value"},{default:()=>[h("span",{class:"rounded-borders text-"+e.deprecatedColor+" bg-"+e.deprecatedBackground},t.deprecated)]})]})}function j(e){return void 0===e.addedIn?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},{default:()=>[h("div",{class:"component-api__row--label"},"Added in"),h("div",{class:"component-api__row--value"},{default:()=>[h("div",e.addedIn)]})]})}function k(e){if(void 0===e.type)return"";const t=Array.isArray(e.type)?e.type.join(" | "):e.type;return h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},{default:()=>[h("div",{class:"component-api__row--label"},"Type"),h("div",{class:"component-api__row--value"},{default:()=>[h("div",t)]})]})}function x(e,t){return void 0===e?"":h("div",{class:"component-api__row--item col-grow"},{default:()=>[h("div",{class:"component-api__row--label"},"Name"),h("div",{class:"component-api__row--value"},{default:()=>[h(QBadge,{class:`property-name ${t}`},{default:()=>e})]})]})}function C(){let t=e.name;"methods"===e.type?t=n(t,e.json):"events"===e.type&&(t=a(t,e.json));const o=0;return h("div",{class:"row full-width"},{default:()=>[x(t,NAME_PROP_COLOR[o]),k(e.json),void 0===e.json.removedIn&&g(e.json),void 0===e.json.deprecated&&j(e.json),y(e.json),w(e.json),v(e.json),b(e.json),_(e.json),f(e.json),d(e.json),p(e.json),l(e.json,o+1),i(e.json,o+1),s(e.json,o+1),c(e.json,o+1)]})}function Q(){return C()}return()=>Q()}}),JsonApiList=defineComponent({name:"JsonApiList",props:{name:{type:String,required:!0},json:{type:Object,required:!0}},setup(e){const t=computed(()=>{return Object.keys(e.json)});function o(){return[...t.value.map(t=>h(QItem,{key:e.name+"-"+t,class:"component-api__list-item"},{default:()=>[h(JsonApiItem,{name:t,type:e.name,json:e.json[t]})]}))]}function n(){const t=0!==Object.keys(e.json).length?o():h("div",{staticClass:"q-pa-md text-grey-7"},"No matching entries found. Please refine the filter.");return h(QList,{class:"component-api__list",separator:!0},{default:()=>t})}function a(){return n()}return()=>a()}});function copyToClipboard(e){const t=document.createElement("textarea");t.className="fixed-top",t.value=e,document.body.appendChild(t),t.focus(),t.select(),document.execCommand("copy"),document.body.removeChild(t)}function copyHeading(e){const t=window.location.origin+window.location.pathname+"#"+e,o=document.getElementById(e);o&&(o.id=""),"replaceState"in history?history.replaceState(history.state,"",`${location.pathname}#${e}`):window.location.hash="#"+e,o&&setTimeout(()=>{o.id=e},300),copyToClipboard(t),Notify.create({message:"Anchor has been copied to clipboard.",position:"top",color:"white",textColor:"primary",actions:[{icon:"cancel",color:"red-8",dense:!0,round:!0}],timeout:2e3})}const specialRE=/[\s·/_\\,:;\.\(\)\[\]]+/g,andRE=/&/g,nonWordRE=/[^\w-]+/g,multipleDashRE=/--+/g;function slugify(e){return String(e).toLowerCase().replace(specialRE,"-").replace(andRE,"-and-").replace(nonWordRE,"").replace(multipleDashRE,"-")}var version$1="2.0.0-alpha.5",Component=defineComponent({name:"JsonApiViewer",directives:{ClosePopup:ClosePopup},props:{title:{type:String,required:!0},json:{type:Object,required:!0},type:{type:String,default:"Vue Component"},noMenu:Boolean,startingTab:{type:String,default:null},startingInnerTab:{type:String,default:null},noFooter:Boolean},setup(e,{slots:t}){const o=ref(!1),n=ref("props"),a=ref("model"),r=ref(null),l=ref(null),i=ref([]),s=reactive({}),c=reactive({}),d=reactive({}),u=ref("lightblue"),p=ref("light-blue-2"),m=ref(!1),f=ref(!1),v=ref(null),w=getCurrentInstance(),_=w.proxy.$q||w.ctx.$q||useQuasar(),b=computed(()=>slugify(e.title));function y(t){if(void 0===t)return void(o.value=!0);const n=extend(!0,{},t);if(void 0!==n.type&&delete n.type,n.meta&&delete n.meta,Q(),void 0!==n.props){const t=Object.keys(n.props).sort();for(let a=0;a<t.length;++a){const o=t[a],r=n.props[o];if(void 0===r.deprecated||!0===e.showDeprecated)if(void 0===r.removedIn||!0===e.showRemoved)if(void 0===d[r.category]&&(d[r.category]={}),x(o))d[r.category][o]=r;else{const e=j(r);Object.keys(e).length>0?d[r.category][o]=e:delete n.props[o]}else delete n.props[o];else delete n.props[o]}O(c);const o=Object.keys(d);for(let e=0;e<o.length;++e){const t=o[e];c[t]=Object.keys(d[t]).length}}g(n);const a=Object.keys(n);for(let e=0;e<a.length;++e){const t=a[e];i.value[t]=Object.keys(n[t]).length}r.value=n,o.value=!0}function g(t){const o=Object.keys(t);for(let n=0;n<o.length;++n){const a=o[n];if("props"!==a){const o=Object.keys(t[a]);for(let n=0;n<o.length;++n){const r=o[n],l=t[a][r];if(void 0!==l.deprecated&&!0!==e.showDeprecated&&delete t[a][r],void 0!==l.removedIn&&!0!==e.showRemoved)delete t[a][r];else if(!0!==x(r)){const e=j(l);0===Object.keys(e).length&&delete t[a][r]}}}}}function j(e){if(null===l.value)return e;let t=!1;const o=Object.keys(e);for(let n=0;n<o.length;++n){const a=e[o[n]],r=Object.prototype.toString.call(a);if("[object Array]"===r){if(C(a)){t=!0;break}}else if(("[object String]"===r||"[object Number]"===r)&&k(a)){t=!0;break}}return!0!==t?{}:e}function k(e){if(l.value)return String(e).toLowerCase().indexOf(l.value.toLowerCase())>=0}function x(e){return k(e)}function C(e){for(let t=0;t<e.length;++t)if(!0===k(e[t]))return!0;return!1}function Q(){O(d),O(c),O(s),i.value=[]}function O(e){Object.keys(e).forEach(t=>{delete e[t]})}function I(){null!==l.value&&(l.value=null),v.value.focus()}function S(){return h(QToolbarTitle,{class:!0!==e.noAnchor?"text-subtitle1 component-api__title":"",onClick:copyHeading},{default:()=>h("span",{class:"ellipsis"},e.title)})}function T(){return h(QInput,{ref:v,class:"q-mx-sm",placeholder:"Filter...",modelValue:l.value,inputClass:"text-right",dense:!0,borderless:!0,"onUpdate:modelValue":e=>{l.value=e}},{append:()=>h(QIcon,{class:"cursor-pointer",name:null!==l.value?"clear":"search",onClick:I})})}function A(){return h(QToolbar,{},{default:()=>[S(),h("div",{class:"q-ml-md col-auto text-grey text-caption"},{default:()=>[_.screen.gt.xs&&e.type]}),_.screen.width>=385&&T(),!0!==e.noMenu&&q()]})}function q(){return h(QIcon,{class:"cursor-pointer text-grey",name:"menu",size:"md"},{default:()=>[h(QMenu,{default:()=>[h("div",{class:"row no-wrap q-pa-md"},{default:()=>[h("div",{class:"column"},{default:()=>[h(QCheckbox,{modelValue:m.value,label:"Show deprecated","onUpdate:modelValue":e=>{m.value=e}}),h(QCheckbox,{modelValue:f.value,label:"Show removed","onUpdate:modelValue":e=>{f.value=e}})]})]})]})]})}function P(){return h("div",{class:"row justify-between items-center no-wrap"+(_.dark.isActive?"":" bg-white text-grey-7")},{default:()=>[h(QTabs,{class:"col-grow text-caption"+(_.dark.isActive?"":" bg-white text-grey-7"),modelValue:n.value,dense:!0,activeColor:_.dark.isActive?"yellow":"primary",indicatorColor:_.dark.isActive?"yellow":"primary",align:"left",narrowIndicator:!0,"onUpdate:modelValue":e=>{n.value=e}},{default:()=>R(i.value)})]})}function R(e){return[...Object.keys(e).map(t=>h(QTab,{key:t+"-tab",name:t,style:{paddingRight:0}},{default:()=>[V(t,e[t])]}))]}function V(e,t,o){return h("div",{class:"row no-wrap items-center self-stretch q-pr-sm"+(o?" justify-between":""),style:{minWidth:!0===o?"120px":void 0}},{default:()=>[h("span",{class:"q-mr-xs text-capitalize text-weight-medium"},e),t>0&&h(QBadge,null,{default:()=>t})]})}function E(){return h(QTabPanels,{modelValue:n.value,animated:!0,"onUpdate:modelValue":e=>{n.value=e}},{default:()=>B()})}function B(){return[...Object.keys(i.value).map(e=>h(QTabPanel,{key:e+"-panel",class:"q-pa-none",name:e},{default:()=>["props"===e&&M(e,r.value[e]),"props"!==e&&L(e,r.value[e])]}))]}function L(e,t){return h("div",{class:"component-api__container"},{default:()=>[h(JsonApiList,{name:e,json:t})]})}function M(e,t){return h("div",{class:"fit row"},{default:()=>[h("div",{class:"col-auto row no-wrap q-py-lg"+(_.dark.isActive?"":" bg-white text-grey-7")},{default:()=>[h(QTabs,{class:"text-caption"+(_.dark.isActive?"":" bg-white text-grey-7"),modelValue:a.value,dense:!0,vertical:!0,activeColor:_.dark.isActive?"yellow":"primary",indicatorColor:_.dark.isActive?"yellow":"primary",align:"left",narrowIndicator:!0,"onUpdate:modelValue":e=>{a.value=e}},{default:()=>[...Object.keys(c).map(e=>h(QTab,{key:e+"-inner-tab",class:"col-grow",name:e},{default:()=>[V(e,c[e],!0)]}))]})]}),h(QSeparator,{vertical:!0,color:p.value,style:{minHeight:"600px"}}),N()]})}function N(){return h(QTabPanels,{class:"col",modelValue:a.value,animated:!0,transitionPrev:"slide-down",transitionNext:"slide-up","onUpdate:modelValue":e=>{a.value=e}},{default:()=>[$()]})}function $(){return[...Object.keys(d).map(e=>h(QTabPanel,{key:e+"-inner-panel",class:"q-pa-none",name:e},{default:()=>[L(e,d[e])]}))]}function J(){const o=t.footer;if(!0!==e.noFooter)return h("div",{class:"component-api__footer row justify-between items-center"},{default:()=>[o||h("div","Quasar JSON API Viewer v"+version$1+" - Created and maintained by Jeff Galbraith (@hawkeye64)")]})}function D(){return h(QCard,{class:"no-shadow",flat:!0,bordered:!0,style:{border:`${u.value} 1px solid`}},{default:()=>[A(),h(QSeparator,{color:p.value}),P(),h(QSpace),h(QSeparator,{color:p.value}),E(),J()]})}function U(){return h("section",{id:b.value,class:"q-pa-md overflow-auto"},D())}function H(){return h("div",U())}function F(){return H()}return watch(()=>l.value,()=>{y(e.json)}),watch(()=>m.value,()=>{y(e.json)}),watch(()=>f.value,()=>{y(e.json)}),onBeforeMount(()=>{n.value=e.startingTab||n.value,a.value=e.startingInnerTab||a.value,y(e.json)}),()=>F()}});const version="2.0.0-alpha.5";function install(e){e.component(Component.name,Component)}var VuePlugin=Object.freeze({__proto__:null,version:version,Component:Component,install:install});export default VuePlugin;export{Component,install,version};